#include "pch.h"
#include "Lan.h"
#include <locale.h>
#include <mmsystem.h>

// コンストラクタ
CLan::CLan()
	: m_Socket()
	, m_TransferBuffer()
	, m_ReceiveData(_T(""))
{
}

// デストラクタ
CLan::~CLan()
{
}

// (1)接続
BOOL CLan::OpenInterface(CString HostAddress, UINT HostPort)
{
#ifdef _UNICODE
	size_t Length;
#endif
	char IpAddress[64];
	CString ErrorMessage;
	int Result;

#ifdef _UNICODE
	wcstombs_s(&Length, IpAddress, sizeof(IpAddress), HostAddress, _TRUNCATE);			// ワイド文字列をマルチバイト文字列に変換
#else
	_tcscpy_s(IpAddress, sizeof(IpAddress), HostAddress);
#endif
	Result = m_Socket.Connect(IpAddress, HostPort);										// ソケットのオープン
	if (Result != 0) {
		ErrorMessage = GetLastErrorMessage(Result);
		MessageBox(NULL, ErrorMessage, AfxGetAppName(), MB_ICONERROR | MB_OK);
		return FALSE;
	}

	return TRUE;
}

// (2)切断
void CLan::CloseInterface()
{
	CString ErrorMessage;
	int Result;

	Result = m_Socket.Disconnect();														// ソケットのクローズ
	if (Result != 0) {
		ErrorMessage = GetLastErrorMessage(Result);
		MessageBox(NULL, ErrorMessage, AfxGetAppName(), MB_ICONERROR | MB_OK);
	}
}

// (3)コマンド送信
BOOL CLan::SendMsg(CString SendData)
{
#ifdef _UNICODE
	size_t Length;
#endif
	CString ErrorMessage;
	int Result;

	SendData = SendData + _T("\r\n");													// ターミネータ「CR+LF」を付加
#ifdef _UNICODE
	wcstombs_s(&Length, m_TransferBuffer, sizeof(m_TransferBuffer), SendData, _TRUNCATE);	// ワイド文字列をマルチバイト文字列に変換
#else
	_tcscpy_s(m_TransferBuffer, sizeof(m_TransferBuffer), SendData);
#endif
	Result = m_Socket.Send(m_TransferBuffer);											// ソケットに送信
	if (Result != 0) {
		ErrorMessage = GetLastErrorMessage(Result);
		MessageBox(NULL, ErrorMessage, AfxGetAppName(), MB_ICONERROR | MB_OK);
		return FALSE;
	}

	return TRUE;
}

// (4)応答受信
BOOL CLan::ReceiveMsg(DWORD Timeout)
{
	DWORD StartTime;
	CString Buffer;
	BOOL Status = FALSE;
	CString ErrorMessage;
	int Result;

	m_ReceiveData = _T("");																// 受信データをクリア
	StartTime = timeGetTime();
	// ターミネータ「LF」を受信するまでループ
	for (;;) {
		Result = m_Socket.Receive(Buffer, 1000);										// ソケットから受信
		if (Result != 0) {
			m_ReceiveData = _T("Error");
			ErrorMessage = GetLastErrorMessage(Result);
			MessageBox(NULL, ErrorMessage, AfxGetAppName(), MB_ICONERROR | MB_OK);
			Status = FALSE;
			break;
		}
		if (Buffer.GetLength() > 1) {
			Buffer.Replace(_T("\r"), _T(""));											// 受信データ内の「CR」を削除
			int Index = Buffer.Find(_T("\n"));
			if (Index >= 0) {															// ターミネータ「LF」を受信したら終了
				m_ReceiveData = m_ReceiveData + Buffer.Mid(0, Index);					// 「LF」の手前までの受信データを保存
				Status = TRUE;;
				break;
			}
			else {
				m_ReceiveData = m_ReceiveData + Buffer;									// 受信データを保存
			}
		}
		// タイムアウト処理
		if (timeGetTime() > StartTime + Timeout) {
			m_ReceiveData = _T("Timeout");
			Status = FALSE;
			break;
		}
	}

	return Status;
}

// (5)コマンド送受信
BOOL CLan::SendQueryMsg(CString SendData, DWORD Timeout)
{
	BOOL Result;

	Result = SendMsg(SendData);															// コマンド送信
	if (Result == TRUE) {
		if (SendData.Find(_T("?")) != -1) {
			Result = ReceiveMsg(Timeout);												// 送信が成功したら応答を受信
		}
	}

	return Result;
}

// エラーメッセージ取得
CString CLan::GetLastErrorMessage(DWORD MessageId)
{
	PVOID pBuffer = NULL;
	CString ErrorMessage;

	if (FormatMessage(
		FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM | FORMAT_MESSAGE_IGNORE_INSERTS | FORMAT_MESSAGE_MAX_WIDTH_MASK,
		NULL, MessageId, MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), reinterpret_cast<PTSTR>(&pBuffer), 0, NULL) == 0 || pBuffer == NULL) {
		return ErrorMessage;
	}
	ErrorMessage = static_cast<PTSTR>(pBuffer);
	LocalFree(pBuffer);

	return ErrorMessage;
}
